alias -l sfDll { return " $+ $scriptdir $+ SpeedFan.dll" }
alias -l version { return $dll($sfDll, Version, .) }

menu channel,status {
  SpeedFan details
  .&Temperatures:showTemperature
  .&Fans:showFan
  .&Voltages:showVoltage
  .-
  .&About:noop $input($dll($sfDll, Version, .), io, SpeedFan.dll)
}

alias -l getCount {
  var %ret = $dll($sfDll, GetCount, .)

  if ($gettok(%ret, 1, 32) == S_ERR) {
    echo 4 -s *** $gettok(%ret, 2-, 32)
    halt
  }

  if ($1 == Temperature) return $gettok(%ret, 2, 32)
  if ($1 == Fan)         return $gettok(%ret, 3, 32)
  if ($1 == Voltage)     return $gettok(%ret, 4, 32)

  return 0
}

alias -l showTemperature {
  showDetails Temperature C
}

alias showFan {
  showDetails Fan rpm
}

alias showVoltage {
  showDetails Voltage V
}


alias -l showDetails {
  var %k = $getCount($1)
  var %i = 1
  var %labels

  if ($1 == Temperature) {
    %labels = $dll($sfDll, GetLabels, temperature)

    if ($gettok(%labels, 1, 32) != S_OK) %labels = $null
    else %labels = $gettok(%labels, 2-, 32)
  }

  echo -a [[ $1 ]] ----------

  while (%i <= %k) {
    echo -a %i $+ . $iif($gettok(%labels, %i, 44), $ifmatch $+ :, ) $gettok($dll($sfDll, $+(Get, $1), %i), 2-, 32) $2
    inc %i
  }

  echo -a [[ $1 ]] ----------
}
